package org.jenkinsci.plugins.p4_client.workspace;

import org.jenkinsci.plugins.p4_client.client.ConnectionFactory;

import com.perforce.p4java.server.IOptionsServer;

import hudson.model.Descriptor;
import hudson.util.ListBoxModel;

public abstract class WorkspaceDescriptor extends Descriptor<Workspace> {

	public WorkspaceDescriptor(Class<? extends Workspace> clazz) {
		super(clazz);
	}

	protected WorkspaceDescriptor() {
	}

	/**
	 * Magic Stapler method; provides list of Charset types.
	 */
	public ListBoxModel doFillCharsetItems() {
		ListBoxModel list = new ListBoxModel();
		try {
			IOptionsServer p4 = ConnectionFactory.getConnection();
			for (String set : p4.getKnownCharsets()) {
				list.add(set);
			}
		} catch (Exception e) {
		}
		if(list.isEmpty()) {
			list.add("none");
		}
		return list;
	}
}
